/*
 * La solucin de este laboratorio fue
 * bajada desde la pgina del curso IIC1102.
 * 
 * Laboratorio 7 - IIC1102 - Primer Semestre 2005
 * 
 * */

// Laboratorio 7

import iic1102Package.*;

public class Principal {

	public static void main(String[] args) {
		
		// Se declara un centro de urgencia del tipo 1
		Urgencia1 Clinica1;
		
		// Se declara un centro de urgencia del tipo 2
		Urgencia2 Clinica2;
		
		// Tamao mximo de la lista de espera de la Clinica 1 y 2
		int maxLista1;
		int maxLista2;
		
		// Se solicita al usuario el tamao mximo de la lista de espera
		maxLista1 = Interfaz.PedirEntero("Ingrese el tamao mximo de la lista de espera de la Clinica 1");
		maxLista2 = Interfaz.PedirEntero("Ingrese el tamao mximo de la lista de espera de la Clinica 2");
		
		// Se crea los objetos
		Clinica1 = new Urgencia1(maxLista1);
		Clinica2 = new Urgencia2(maxLista2);
	
		// Pacientes
		Paciente [] enfermos= new Paciente[4];
		
		// Creacin de los pacientes
		String datos;
		datos="Karen     "+"Palma     "+"13123121"+"26 "+"1"+"3"+"Fuerte dolor abdominal";
		enfermos[0]=new Paciente(datos);
		datos="Jorge     "+"Andaur    "+"13123122"+"26 "+"2"+"5"+"Fractura de femur";
		enfermos[1]=new Paciente(datos);
		datos="Mnica    "+"Fuenzalida"+"6123123 "+"52 "+"1"+"4"+"Arritmia leve";
		enfermos[2]=new Paciente(datos);
		datos="Jos      "+"Pea      "+"18123123"+"10 "+"2"+"3"+"Fiebre";
		enfermos[3]=new Paciente(datos);
		
		// Opcin del usuario
		int opcion=0;
		
		// Variable para almacenar el paciente que ser atendido
		Paciente atendido;
		
		// Indice para ingresar y eliminar pacientes
		int i;
		
		while(opcion!=3)
		{
			// Se solicita la opcin al usuario
			opcion= Interfaz.PedirEntero("Ingrese su opcin:\r\n"+
					"1.- Simulacin de Urgencia1" +"\r\n"+
					"2.- Simulacin de Urgencia2" +"\r\n"+
					"3.- Terminar");
		
			// Se procesa la opcin
			if(opcion == 1) {
			// Urgencia1
				
				Interfaz.MostrarMensajeConsola("Laboratorio 7 - Solucin\n");
				Interfaz.MostrarMensajeConsola("Simulando el ingreso de pacientes a la Clinica 1");
				
				// Agregar pacientes a la lista de espera
				for(i=0;i<4;i++)
				{
					Interfaz.MostrarMensajeConsola("\nLLeg un nuevo paciente:");
					enfermos[i].imprimirPaciente();
					// Agregar el paciente a la lista de espera					
					Clinica1.llegadaPaciente(enfermos[i]);
					Interfaz.MostrarMensajeConsola("\n****************************Lista de espera:****************************\n");
					Clinica1.imprimirLista();
					Interfaz.MostrarMensajeConsola("************************************************************************\n");
				}
				
				Interfaz.MostrarMensajeConsola("Simulando la atencin de pacientes en la Clinica 1");
				
				// Atendiendo a los pacientes
				for(i=0;i<=4;i++)
				{
					// Solo si hay un paciente que atender, imprimo su informacin y la lista
					atendido = Clinica1.atenderPaciente();
					if(atendido!=null){
						Interfaz.MostrarMensajeConsola("\nAtendido:");
						atendido.imprimirPaciente();
						Interfaz.MostrarMensajeConsola("\n****************************Lista de espera:****************************\n");
						Clinica1.imprimirLista();
						Interfaz.MostrarMensajeConsola("************************************************************************\n");
					}
					else
						Interfaz.MostrarMensajeConsola("No hay pacientes que atender");
					
				}
				// Realice una prueba final: Vea que ocurre con su programa 
				// si trata de sacar un paciente de la lista de espera 
				// cuando est a quedado vacia
				// Para probar esto cambie en el ciclo anterio < por <=
				Interfaz.MostrarMensajeConsola("\n\n");

			} else if(opcion == 2) {
				
				Interfaz.MostrarMensajeConsola("Simulando el ingreso de pacientes a la Clinica 2");
				
				// Agregar pacientes a la lista de espera
				for(i=0;i<4;i++)
				{
					Interfaz.MostrarMensajeConsola("\nLLego un nuevo paciente:");
					enfermos[i].imprimirPaciente();
					// Agregar el paciente a la lista de espera
					Clinica2.llegadaPaciente(enfermos[i]);
					Interfaz.MostrarMensajeConsola("\n****************************Lista de espera:****************************\n");
					Clinica2.imprimirLista();
					Interfaz.MostrarMensajeConsola("************************************************************************\n");
				}
				
				Interfaz.MostrarMensajeConsola("Simulando la atencin de pacientes en la Clinica 2");
				
				// Atendiendo a los pacientes
				for(i=0;i<=4;i++)
				{
					// Solo si pude atender un paciente lo imprimo
					atendido = Clinica2.atenderPaciente();
					if(atendido!=null){
						Interfaz.MostrarMensajeConsola("\nAtendido:");
						atendido.imprimirPaciente();
						Interfaz.MostrarMensajeConsola("\n****************************Lista de espera:****************************\n");
						Clinica2.imprimirLista();
						Interfaz.MostrarMensajeConsola("************************************************************************\n");
					}
					else
						Interfaz.MostrarMensajeConsola("No hay pacientes que atender");
					
				}
				// Realice una prueba final: Vea que ocurre con su programa 
				// si trata de sacar un paciente de la lista de espera 
				// cuando est a quedado vacia
				// Para probar esto cambie en el ciclo anterio < por <=
				Interfaz.MostrarMensajeConsola("\n\n");

			}
		}
		
	}
}
